use std::default::Default;

#[derive(Default)]
pub struct Section {
    pub name:    String,
    pub adr:     Option<u64>,
    pub size:    Option<usize>,
    pub file:    Option<String>,
    pub content: Vec<Content>
}

#[derive(Default)]
pub struct Symbol {
    pub name: String,
    pub adr:  u64,
}

#[derive(Default)]
pub struct Fill {
    pub adr:  u64,
    pub size: usize,
}

pub enum Content {
    Fill(Fill),
    Section(Section),
    Symbol(Symbol),
}

impl Section {
    pub fn new(name: String, adr: Option<u64>, size: Option<usize>, file: Option<String>) -> Section {
        Section{name, adr, size, file, content: Vec::new()}
    }
}

impl Symbol {
    pub fn new(name: String, adr: u64) -> Symbol {
        Symbol{name, adr}
    }
}

impl Fill {
    pub fn new(adr: u64, size: usize) -> Fill {
        Fill{adr, size}
    }
}